## mingw-w64-ccache-4.10-1.src.tar.zst

=== src/third_party/CMakeLists.txt ===
add_subdirectory(cxxurl)
add_subdirectory(win32-compat)

if(NOT TARGET dep_blake3)
  add_subdirectory(blake3)
endif()
if(NOT TARGET dep_cpphttplib)
  add_subdirectory(cpp-httplib)
endif()
if(NOT TARGET dep_nonstdspan)
  add_subdirectory(nonstd-span)
endif()
if(NOT TARGET dep_tlexpected)
  add_subdirectory(tl-expected)
endif()
